#include "mcc_generated_files/mcc.h"

//--------------萔`----------------------------
#define TIME_OFF -1         //^C}[gpȂꍇ
#define TIME_UP 0           //^CAbv
#define LED8_WAIT 10

// ROW 1?8isj
//
//
//
//COL 1?8()

//--------------ϐ`----------------------------
int16_t timLed8;
int8_t c_cnt;
int8_t r_cnt;
uint8_t patnMode;

//--------------֐ߐ錾----------------------------
void mainApp(void);     //C֐ł̏
void mainTimer(void);
void Led8Clr(void);
void Led8Set(int8_t r, int8_t c);
void MultiSet(int8_t r);

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();

    while (1)
    {
        mainApp();
    }
}

/* ^C}Ǘ */
void mainTimer(void){
    
    if( timLed8 > TIME_UP ){
      --timLed8;
    }    
    
}
/* CAv */
void mainApp(void){
    int8_t i;
    
    switch(patnMode){
        case 0:
            if(timLed8 == TIME_UP){
                timLed8 = LED8_WAIT;
                Led8Clr();
                Led8Set(r_cnt, c_cnt);

                if(++c_cnt >= 8){
                    c_cnt = 0;
                    if(++r_cnt >=8){
                        r_cnt = 7;
                        c_cnt = 7;
                        patnMode = 1;
                    }
                }
            }
            break;
        case 1:
            if(timLed8 == TIME_UP){
                timLed8 = LED8_WAIT;
                Led8Clr();
                Led8Set(r_cnt,c_cnt);

                if(--c_cnt < 0){
                    c_cnt = 7;
                    if(--r_cnt < 0){
                        r_cnt = 0;
                        c_cnt = 0;
                        patnMode = 2;
                    }
                }
            }
            break;
        case 2:
            if(timLed8 == TIME_UP){
                timLed8 = LED8_WAIT;
                Led8Clr();
                Led8Set(r_cnt,c_cnt);

                if(++r_cnt >= 8){
                    r_cnt = 0;
                    if(++c_cnt >=8){
                        r_cnt = 7;
                        c_cnt = 7;
                        patnMode = 3;
                    }
                }
            }
          break;
        case 3:
            if(timLed8 == TIME_UP){
                timLed8 = LED8_WAIT;
                Led8Clr();
                Led8Set(r_cnt,c_cnt);

                if(--r_cnt < 0){
                    r_cnt = 7;
                    if(--c_cnt < 0 ){
                        r_cnt = 0;
                        c_cnt = 0;
                        patnMode = 4;
                    }
                }
            }            
            break;          
        case 4:
            if(timLed8 == TIME_UP){
                timLed8 = LED8_WAIT;
                Led8Clr();

                for(i=0; i < 8; i++){
                    Led8Set(r_cnt,i);
                }
                if(++r_cnt >=8){
                    r_cnt = 0;
                    c_cnt = 0;
                    patnMode = 5;
                }
            }
          break;
        case 5:
            if( timLed8 == TIME_UP){
                timLed8 = LED8_WAIT;
                if(++c_cnt >=8){
                    r_cnt =0;
                    c_cnt = 0;
                    patnMode = 0;
                }
            }

            Led8Clr();
            Led8Set(r_cnt,c_cnt);

            if(++r_cnt >= 8){
                r_cnt = 0;
            }            
            break;
        }
}    

/* LEDWON/OFF */
void Led8Set(int8_t r, int8_t c){
 
    MultiSet(r);
    
    switch(c){
        case 0:
            IO_RB0_SetLow();
            break;
        case 1:
            IO_RB1_SetLow();
            break;            
        case 2:
            IO_RB2_SetLow();
            break;
        case 3:
            IO_RB3_SetLow();
            break;
        case 4:
            IO_RB4_SetLow();
            break;
        case 5:
            IO_RB5_SetLow();
            break;
        case 6:
            IO_RB6_SetLow();
            break;
        case 7:
            IO_RB7_SetLow();
            break;            
    }
}
/* }`vNT̑ */
void MultiSet(int8_t r ){
    uint8_t porta;
    
    IO_RA7_SetLow(); //INHLOW
    porta = PORTA;
    porta &= 0xD8; //PA0?PA2}XN
    PORTA = porta | (r & 0x07); //A,B,C_a
    IO_RA6_SetHigh(); //COMHIGH
}
/* LED}gNXׂOFF */
void Led8Clr(void){
    
    IO_RA7_SetHigh(); //INHHIGH
    IO_RA6_SetLow(); //COMLOW
    PORTB = 0xFF; //COLOFF
}
/* End of File */